// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
// C++ Interface: AxForward
//
// Description: 
//
//
// Author: Janusz SP9UMX <sp9umx@sr9zaa.ampr.org>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include <qthread.h>
#include <qevent.h>

class TAxForward : public QThread
{
	public:
		TAxForward();
		void run();
		void stop();
  
//private:
		volatile bool stopped;
    
	protected:
		QString striplf( QString s );
		QString call_call ( QString src );
		void send_FQ();
		void mark_record ( int msgnum );
		int send_data( QString subject, char *body, long size);
		void send_block();
		int forward_message( int num, QString types,QString mid,QString from,QString to_a,QString at,QString subject);
		void start_forward();
		void ForwardEvent();
		void UpdateStatus( int progress, int progressMax, QString L_Stat, QString L_MNr, QString L_MT, bool reset );
};
